<%@ taglib prefix='c' uri='http://java.sun.com/jstl/core' %><%@
	page language="java"
	import="org.acegisecurity.ui.AbstractProcessingFilter,
			org.acegisecurity.ui.webapp.AuthenticationProcessingFilter,
			org.acegisecurity.AuthenticationException,
			org.pentaho.platform.uifoundation.component.HtmlComponent,
			org.pentaho.platform.engine.core.system.PentahoSystem,
			org.pentaho.platform.util.messages.LocaleHelper,
			org.pentaho.platform.util.web.SimpleUrlFactory,
			org.pentaho.platform.api.engine.IPentahoSession,
			org.pentaho.platform.api.engine.IUITemplater,
			org.pentaho.platform.api.repository.ISolutionRepository,
			org.pentaho.platform.web.http.PentahoHttpSessionHelper,
			org.pentaho.platform.web.jsp.messages.Messages,
			org.pentaho.platform.web.http.request.HttpRequestParameterProvider,
			org.pentaho.platform.web.http.session.HttpSessionParameterProvider,
			org.dom4j.*,
			java.util.*,
			org.apache.commons.lang.StringEscapeUtils"
%><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN"
         "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>Pentaho Platform</title>
<meta name="viewport" content="width=320; initial-scale=1.0; maximum-scale=1.0; user-scalable=0;"/>
<style type="text/css" media="screen">@import "/pentaho-style/iui/iui.css";</style>
<script type="application/x-javascript" src="/pentaho-style/iui/iui.js"></script>
</head>
<body>
    <div class="toolbar">
        <h1 id="pageTitle"></h1>
        <a id="backButton" class="button" href="#"></a>
        <a id="rightButton" class="button" href="#"></a>
    </div>
<%

	response.setCharacterEncoding(LocaleHelper.getSystemEncoding());
	HttpSession httpSession = request.getSession();
	
	boolean doSplash = httpSession.getAttribute( "dopentahosplash" ) == null || "true".equals( request.getParameter("splash") );
	doSplash = false;
	httpSession.setAttribute( "dopentahosplash", "false" );
	 
	String baseUrl = PentahoSystem.getApplicationContext().getBaseUrl();
	
	IPentahoSession userSession = PentahoHttpSessionHelper.getPentahoSession( request );
		
	HttpRequestParameterProvider requestParameters = new HttpRequestParameterProvider( request );
	HttpSessionParameterProvider sessionParameters = new HttpSessionParameterProvider( userSession );
	String hrefUrl = baseUrl; //$NON-NLS-1$
	String onClick = ""; //$NON-NLS-1$
	String thisUrl = baseUrl + "Navigate?"; //$NON-NLS-1$
	
	SimpleUrlFactory urlFactory = new SimpleUrlFactory( thisUrl );
	ArrayList messages = new ArrayList();


    ISolutionRepository repository = PentahoSystem.get(ISolutionRepository.class, userSession);

//    if (repository == null) {
//      error(Messages.getErrorString("NavigationComponent.ERROR_0001_BAD_SOLUTION_REPOSITORY")); //$NON-NLS-1$
//      return null;
//    }

    String solution = request.getParameter("solution");
    String path = request.getParameter("path");
    if ("".equals(solution)) { //$NON-NLS-1$
      solution = null;
    }
    if ("".equals(path)) { //$NON-NLS-1$
      path = null;
    }
    Document document = repository.getNavigationUIDocument(solution, path, ISolutionRepository.ACTION_EXECUTE);
    
    // display correct back button, one level up...
    
    StringBuffer addlLists = new StringBuffer();
    String displayPath = "Solution Repository";
    if (solution != null && path != null) {
    	displayPath = solution + " / " + path;
    } else if (solution != null) { 
        displayPath = solution;
    }
    
    String dispId = "nav_" + displayPath.replaceAll("\\W","_");
%><%!
  public static String getElementText(Element parentElement, String childElement) {
    List elements = parentElement.elements(childElement);
    if (elements.size() == 0) return null;
	return ((Element)elements.get(0)).getTextTrim();
  }
%>
    <ul id="<%= dispId %>" title="Pentaho BI" selected="true" rightButtonName="Logout" rightButtonHref="Logout">
        <li class="group"><%= displayPath %></li>
        <%
           // find solution / path
           List elements = null;
           
           if (solution == null) {
				elements = document.getRootElement().elements("file");
		   } else {
		        if (path == null) {
					Element solutionElement = (Element)document.getRootElement().selectSingleNode("file[@name='" + solution +"']");		        
			        elements = solutionElement.elements("file");
			    } else {
			    	Element parent = null ;
			    	try {
			    		parent = (Element)document.getRootElement().selectSingleNode("file[@path='" + path +"']");
			    	} catch (Exception e) {
			    		
			    	}
			    	elements = parent.elements("file");
			    }
		   }
		   
		   // sort elements
		   List sortedElements = new ArrayList(elements);
		   Collections.sort(sortedElements, new Comparator() {
		   		public int compare(Object o1, Object o2) {
		   			Element e1 = (Element)o1;
		   			Element e2 = (Element)o2;
		   			String title1 = getElementText(e1, "title");
		   			String title2 = getElementText(e2, "title");
		   			return title1.compareTo(title2);
		   		}
		   });
		   
        	for (int i = 0; i < sortedElements.size(); i++) {
        	   Element file = (Element)sortedElements.get(i);
        	   if (file.attributeValue("visible").equals("false")) {
        	     continue;
        	   }
        	   String filesolution = getElementText(file, "solution");
        	   String filetitle = getElementText(file, "title");
        	   if (filetitle !=null) {
        		   if (filetitle.length() > 2 && filetitle.charAt(2) == '.') {
        			   filetitle = filetitle.substring(3);
        		   } else if (filetitle.length() > 3 && filetitle.charAt(3) == '.') {
        			   filetitle = filetitle.substring(4);
        		   }
        	   }
        	   
        	   if (file.attributeValue("type").equals("FILE.FOLDER")) {
	          	   String filepath = file.attributeValue("path");        	     
	        	   %><li><a href="Navigate?solution=<%=filesolution %>&path=<%=filepath %>"><%= filetitle %></a></li><%
        	   } else if (file.attributeValue("type").equals("FILE.ACTIVITY")) {
	          	   String filepath = getElementText(file, "path");
	          	   String filedesc = getElementText(file, "description");	          	   
	          	   String filename = getElementText(file, "filename");
	          	   String fileauthor = getElementText(file, "author");
	          	   String href = (filesolution + "/" + filepath +"/" + filename).replaceAll(" ", "_");
	          	   %><li><a href="#<%= href %>"><%= filetitle %></a></li><%
				   addlLists.append("<ul id=\"" + href + "\" rightButtonName=\"Logout\" rightButtonHref=\"Logout\">");
				   addlLists.append("<li class=\"group\">Title</li>");
				   addlLists.append("<li>" + filetitle+ "</li>");
				   addlLists.append("<li class=\"group\">Description</li>");				   
				   addlLists.append("<li>" + filedesc + "</li>");
				   addlLists.append("<li class=\"group\">Author</li>");				   
				   addlLists.append("<li>" + fileauthor + "</li>");
   				   addlLists.append("<li class=\"group\">Actions</li>");
				   addlLists.append("<li><a href=\"ViewAction?solution=" + filesolution + "&path=" + filepath + "&action=" + filename + "\" target=\"_new\">Run</a></li>");				   
				   addlLists.append("</ul>\n\n");
			   } else if (file.attributeValue("type").equals("FILE.URL")) {
   	          	   String fileurl = getElementText(file, "url");
			   	   %><li><a href="<%=fileurl %>" target="_blank"><%= filetitle %></a></li><%
        	   } else {
    				%><li>Dunno : <%= file.asXML() %></li><%
        	   }
        	}
        %>
    </ul>
    <!-- <%= document.getRootElement().asXML() %> -->
    <%= addlLists.toString() %>
</body>
</html>
